#!/usr/bin/env python
# -*- coding: UTF-8 -*-

#import gtk
import gi
gi.require_version('Gtk','3.0')
from gi.repository import Gtk, Gio, GLib, GObject, Gdk
Gdk.threads_init()
import logging


class Gtk_parent(object):
    
    def __init__(self, glade_file):
        try:
            f_opened = open(glade_file, "r")
            string_readed = f_opened.read()
            f_opened.close()
        except Exception as e:
            logging.error("Imposible abrir %s para cargar UI: %s" 
                          %(glade_file, e))
            raise Exception("Error creando UI a partir de .glade: %s" %e)
        try:
            self.__gtk_builder = Gtk.Builder( )
            self.__gtk_builder.add_from_string(string_readed)
        except Exception as e:
            logging.error("Imposible construir GtkBuilder con %s: %s"
                           %(glade_file, repr(e)))
            raise
        self.inicialize()
        
    def inicialize(self):
        self.init_widgets()
        self.connect_signals()
    
    def connect_signals(self):
        raise NotImplementedError
    
    def init_widgets(self):
        raise NotImplementedError
    
    def get_widget(self, name):
        return self.__gtk_builder.get_object(name)
    
    